/*
   Copyright (C) 1994-2001 Digitool, Inc
   This file is part of OpenMCL.  

   OpenMCL is licensed under the terms of the Lisp Lesser GNU Public
   License , known as the LLGPL and distributed with OpenMCL as the
   file "LICENSE".  The LLGPL consists of a preamble and the LGPL,
   which is distributed with OpenMCL as the file "LGPL".  Where these
   conflict, the preamble takes precedence.  

   OpenMCL is referenced in the preamble as the "LIBRARY."

   The LLGPL is also available online at
   http://opensource.franz.com/preamble.html

*/


	
	include(lisp.s)
	_beginfile
	
local_label(start):	
define([_spentry],[ifdef([__func_name],[_endfn],[])
        .align 8
	_exportfn(_SP$1)
	.line  __line__
])

             
define([_endsubp],[
	_endfn(_SP$1)
# __line__
])

define([xjmp],[
        .globl $1
        b $1
# __line__
])
	
define([_spentryX],[
        _spentry($1)
        xjmp($1)
])
               
define([jump_builtin],[
	ref_nrs_value(fname,builtin_functions)
	set_nargs($2)
	vrefr(fname,fname,$1)
	jump_fname()
])
	


_spentry(jmpsym)
	__(jump_fname())
        
_spentry(jmpnfn)
	__(jump_nfn())
        
	/* Call temp0 if it's either a symbol or function */
_spentry(funcall)
	__(do_funcall())
	
_spentry(mkcatch1v)
	__(li imm2,0)
	__(mkcatch())

_spentry(mkunwind)
	__(lwi(arg_z,unbound_marker))
	__(li imm2,fixnum_one)
	__(mkcatch())
	
_spentry(mkcatchmv)
	__(li imm2,fixnum_one)
	__(mkcatch())

_spentryX(throw)


_spentryX(nthrowvalues)


_spentryX(nthrow1value)


/* Bind special symbol in arg_y to value in arg_z. */
_spentry(bind)
	__(ldr(imm0,symbol.flags(arg_y)))
	__(ori imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm1,tcr.db_link(rcontext)))
	__(vpush(arg_z))
	__(vpush(arg_y))
	__(vpush(imm1))
	__(str(vsp,tcr.db_link(rcontext)))
	__(str(imm0,symbol.flags(arg_y)))
	__(blr)
       
_spentry(bind_self)
	/* Uh, this isn't exactly easy with deep binding.
	   Do the lookup inline, so any error will be
	   more intelligible */
	__(ldr(imm0,symbol.flags(arg_z)))
	__(andi. imm0,imm0,sym_vbit_bound_mask)
	__(mr arg_y,arg_z)
	__(ldr(imm2,tcr.db_link(rcontext)))
	__(cmpri(cr1,imm2,0))
	__(beq 2f)
	__(b 1f)
0:	__(mr imm1,imm2)
	__(ldr(temp0,4(imm1)))
	__(cmpr(temp0,arg_y))
	__(ldr(imm2,0(imm1)))
	__(cmpri(cr1,imm2,0))
	__(bne 1f)
	__(ldr(arg_z,8(imm1)))
	__(b 9f)        
1:	__(bne cr1,0b)
2:	__(ldr(arg_z,symbol.vcell(arg_y)))
9:      __(ldr(imm0,symbol.flags(arg_y)))
	__(ori imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm1,tcr.db_link(rcontext)))
	__(vpush(arg_z))
	__(vpush(arg_y))
	__(vpush(imm1))
	__(str(vsp,tcr.db_link(rcontext)))
	__(str(imm0,symbol.flags(arg_y)))
	__(blr)


/* Bind special symbol in arg_z to  NIL. */
_spentry(bind_nil)
	__(ldr(imm0,symbol.flags(arg_z)))
	__(ori imm0,imm0,sym_vbit_bound_mask)
	__(li temp1,nil_value)
	__(ldr(imm1,tcr.db_link(rcontext)))
	__(vpush(temp1))
	__(vpush(arg_z))
	__(vpush(imm1))
	__(str(vsp,tcr.db_link(rcontext)))
	__(str(imm0,symbol.flags(arg_z)))
	__(blr)
       

/* Undo one special binding. */
_spentry(unbind)
	__(ldr(imm1,tcr.db_link(rcontext)))
	__(ldr(imm1,0(imm1)))
	__(str(imm1,tcr.db_link(rcontext)))
	__(blr)


/* Undo N special bindings: imm0 = n, unboxed and >0. */
_spentry(unbind_n)
	__(ldr(imm1,tcr.db_link(rcontext)))
1:
	__(cmpri(cr0,imm0,1))
	__(subi imm0,imm0,1)
	__(ldr(imm1,0(imm1)))
	__(bne cr0,1b)
	__(str(imm1,tcr.db_link(rcontext)))
	__(blr)

/* Unwind special bindings until the head of the linked list = imm0. */
_spentry(unbind_to)
	__(str(imm0,tcr.db_link(rcontext)))
	__(blr)

_spentry(conslist)
	__(li arg_z,nil_value)
	__(cmpri(nargs,0))
	__(b 2f)	
1:
	__(ldr(temp0,0(vsp)))
	__(cmpri(nargs,fixnum_one))
	__(la vsp,4(vsp))
	__(Cons(arg_z,temp0,arg_z))
	__(subi nargs,nargs,fixnum_one)
2:
	__(bne 1b)
	__(blr)
	
/* do list*: last arg in arg_z, all others vpushed, nargs set to #args vpushed. */
/* Cons, one cons cell at at time.  Maybe optimize this later. */
_spentry(conslist_star)
	__(cmpri(nargs,0))
	__(b 2f)	
1:
	__(ldr(temp0,0(vsp)))
	__(cmpri(nargs,fixnum_one))
	__(la vsp,4(vsp))
	__(Cons(arg_z,temp0,arg_z))
	__(subi nargs,nargs,fixnum_one)
2:
	__(bne 1b)
	__(blr)

/* We always have to create a tsp frame (even if nargs is 0), so the compiler 
   doesn't get confused. */
_spentry(stkconslist)
	__(li arg_z,nil_value)
	__(cmpri(cr1,nargs,0))
	__(add imm1,nargs,nargs)
	__(addi imm1,imm1,tsp_frame.fixed_overhead)
	__(TSP_Alloc_Var_Boxed(imm1,imm2))
	__(la imm1,tsp_frame.data_offset+fulltag_cons(tsp))
	__(b 2f)
1:	__(ldr(temp0,0(vsp)))
	__(cmpri(cr1,nargs,fixnum_one))
	__(la vsp,4(vsp))
	__(rplaca(imm1,temp0))
	__(rplacd(imm1,arg_z))
	__(mr arg_z,imm1)
	__(la imm1,cons.size(imm1))
	__(la nargs,-fixnum_one(nargs))
2:
	__(bne cr1,1b)
	__(blr)

/* do list*: last arg in arg_z, all others vpushed, 
	nargs set to #args vpushed. */
_spentry(stkconslist_star)
	__(cmpri(cr1,nargs,0))
	__(add imm1,nargs,nargs)
	__(addi imm1,imm1,tsp_frame.fixed_overhead)
	__(TSP_Alloc_Var_Boxed(imm1,imm2))
	__(la imm1,tsp_frame.data_offset+fulltag_cons(tsp))
	__(b 2f)
1:	__(ldr(temp0,0(vsp)))
	__(cmpri(cr1,nargs,fixnum_one))
	__(la vsp,4(vsp))
	__(rplaca(imm1,temp0))
	__(rplacd(imm1,arg_z))
	__(mr arg_z,imm1)
	__(la imm1,cons.size(imm1))
	__(la nargs,-fixnum_one(nargs))
2:
	__(bne cr1,1b)
	__(blr)


/* Make a stack-consed simple-vector out of the NARGS objects 
	on top of the vstack; return it in arg_z. */
_spentry(mkstackv)
	__(cmpri(cr1,nargs,0))
	__(dnode_align(imm1,nargs,tsp_frame.fixed_overhead+node_size))
	__(TSP_Alloc_Var_Boxed_nz(imm1,imm2))
	__(slwi imm0,nargs,num_subtag_bits-fixnumshift)
	__(ori imm0,imm0,subtag_simple_vector)
	__(str(imm0,tsp_frame.data_offset(tsp)))
	__(la arg_z,tsp_frame.data_offset+fulltag_misc(tsp))
	__(beq- cr1,2f)
	__(la imm0,misc_data_offset(arg_z))
	__(add imm1,imm0,nargs)
1:
	__(la nargs,-4(nargs))
	__(cmpri(cr1,nargs,0))
	__(ldr(temp1,0(vsp)))
	__(la vsp,4(vsp))
	__(stwu temp1,-4(imm1))
	__(bne cr1,1b)
2:
	__(blr)

	
/* like misc_ref, only the boxed subtag is in arg_x. 
*/
_spentry(subtag_misc_ref)
	__(trap_unless_fulltag_equal(arg_y,fulltag_misc,imm0))
	__(trap_unless_lisptag_equal(arg_z,tag_fixnum,imm0))
	__(vector_length(imm0,arg_y,imm1))
	__(trlge(arg_z,imm0))
	__(unbox_fixnum(imm1,arg_x))
	__(xjmp(misc_ref_common))
        
        
/* Is it worth trying to avoid (postpone) consing here ? */
_spentry(newblocktag)
        __(li imm1,lisp_globals.block_tag_counter)
1:              
        __(lwarx imm0,0,imm1)
	__(addi imm0,imm0,1<<num_subtag_bits)
	__(cmpri(imm0,0))
	__(ori arg_z,imm0,subtag_block_tag)
	__(beq- local_label(cons_nil_nil))
        __(stwcx. imm0,0,imm1)
        __(bne- 1b)
        __(isync)
	__(blr)
	
_spentry(newgotag)
        __(li imm1,lisp_globals.go_tag_counter)
1:      __(lwarx imm0,0,imm1)
	__(addi imm0,imm0,1<<num_subtag_bits)
	__(cmpri(imm0,0))
	__(ori arg_z,imm0,subtag_go_tag)
	__(beq- local_label(cons_nil_nil))
        __(stwcx. imm0,0,imm1)
        __(bne- 1b)
        __(isync)
	__(blr)
local_label(cons_nil_nil):      
	__(li imm0,nil_value)
	__(Cons(arg_z,imm0,imm0))
	__(blr)

	
_spentryX(stack_misc_alloc)

/* subtype (boxed, of course) is vpushed, followed by nargs bytes worth of */
/* initial-contents.  Note that this can be used to cons any type of initialized */
/* node-header'ed misc object (symbols, closures, ...) as well as vector-like */
/* objects. */
/* Note that we're guaranteed to win (or force GC, or run out of memory) */
/* because nargs < 32K. */
_spentry(gvector)
	__(ldrx(arg_z,vsp,nargs))
	__(unbox_fixnum(imm0,arg_z))
	__(rlwimi imm0,nargs,num_subtag_bits-fixnum_shift,0,31-num_subtag_bits)
        __(dnode_align(imm1,nargs,node_size))
	__(Misc_Alloc(arg_z,imm0,imm1))
	__(mr imm1,nargs)
	__(addi imm2,imm1,misc_data_offset)
	__(b 2f)
1:
	__(stwx temp0,arg_z,imm2)
2:
	__(subi imm1,imm1,node_size)
	__(cmpri(cr0,imm1,0))
	__(subi imm2,imm2,node_size)
	__(vpop(temp0))         /* Note the intentional fencepost:
				      discard the subtype as well. */
	__(bge cr0,1b)
	__(blr)
	
	.globl C(nvalret)
	
	/* Come here with saved context on top of stack. */
_spentry(nvalret)
C(nvalret):	
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(temp0,lisp_frame.savevsp(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(discard_lisp_frame())
        __(b local_label(return_values))
	
/* funcall temp0, returning multiple values if it does. */
_spentry(mvpass)
	__(mflr loc_pc)
	__(mr imm0,vsp)
	__(cmpri(cr0,nargs,4*nargregs))
	__(create_lisp_frame())
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(fn,lisp_frame.savefn(sp)))
	__(ref_global(loc_pc,ret1val_addr))
	__(ble+ cr0,1f)
	__(subi imm0,imm0,4*nargregs)
	 __(add imm0,imm0,nargs)
1:
	__(str(imm0,lisp_frame.savevsp(sp)))
	__(li fn,0)
	__(mtlr loc_pc)
	__(do_funcall())
	
/* ret1valn returns "1 multiple value" when a called function does not */
/* return multiple values.  Its presence on the stack (as a return address) */
/* identifies the stack frame to code which returns multiple values. */

_exportfn(C(ret1valn))
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(mtlr loc_pc)
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(discard_lisp_frame())
	__(vpush(arg_z))
	__(set_nargs(1))
	__(blr)
	
_spentry(fitvals)
	__(subf. imm0,nargs,imm0)
	__(li imm1,nil_value)
	__(bge 2f)
	__(sub vsp,vsp,imm0)
	__(blr)
1:
	__(subic. imm0,imm0,4)
	__(vpush(imm1))
	__(addi nargs,nargs,4)
2:
	__(bne 1b)
	__(blr)


_spentry(nthvalue)
	__(add imm0,vsp,nargs)
	__(ldr(imm1,0(imm0)))
	__(cmplr(imm1,nargs))	/*  do unsigned compare:	 if (n < 0) => nil. */
	__(li arg_z,nil_value)
	__(neg imm1,imm1)
	__(subi imm1,imm1,4)
	__(bge 1f)
	__(ldrx(arg_z,imm0,imm1))
1:	
	__(la vsp,4(imm0))
	__(blr)
        

	/* Come here to return multiple values when */
	/* the caller's context isn't saved in a lisp_frame. */
	/* lr, fn valid; temp0 = entry vsp */

_spentry(values)
	__(mflr loc_pc)
local_label(return_values):	
	__(ref_global(imm0,ret1val_addr))
	__(li arg_z,nil_value)
	/* max tsp frame is 4K. 8+8 is overhead for save_values_to_tsp below */
	/* and @do_unwind in nthrowvalues in "sp_catch.s". */
	__(cmpri(cr2,nargs,4096-(8+8)))
	__(cmpr(cr1,imm0,loc_pc))
	__(cmpri(cr0,nargs,fixnum_one))
	__(bge cr2,2f)
	__(beq+ cr1,3f)
	__(mtlr loc_pc)
	__(add imm0,nargs,vsp)
	__(blt- cr0,1f)
	__(ldr(arg_z,-4(imm0)))
1:
	__(mr vsp,temp0)
	__(blr)

2:
	__(uuo_interr(error_too_many_values,nargs))
	__(b 2b)

/* Return multiple values to real caller. */
3:
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(add imm1,nargs,vsp)
	__(mtlr loc_pc)
	__(ldr(imm0,lisp_frame.savevsp(sp)))
	__(cmpr(cr0,imm1,imm0)) /* a fairly common case */
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(cmpri(cr1,nargs,fixnum_one)) /* sadly, a very common case */
	__(discard_lisp_frame())
	__(beqlr cr0) /* already in the right place */
	__(bne cr1,4f)
	 __(ldr(arg_z,0(vsp)))
	 __(mr vsp,imm0)
	 __(vpush(arg_z))
	 __(blr)
4:
	__(blt cr1,6f)
	__(li imm2,fixnum_one)
5:
	__(cmpr(cr0,imm2,nargs))
	__(addi imm2,imm2,fixnum_one)
	__(lwzu arg_z,-4(imm1))
	__(push(arg_z,imm0))
	__(bne cr0,5b)
6:
	__(mr vsp,imm0)
	__(blr)
	
/* Provide default (NIL) values for &optional arguments; imm0 is 
   the (fixnum) upper limit on the total of required and &optional 
   arguments.  nargs is preserved, all arguments wind up on the 
   vstack. */
_spentry(default_optional_args)
	__(cmplr( cr7,nargs,imm0))
	__(li imm4,nil_value)
	__(vpush_argregs())
	__(mr imm1,nargs)
	__(bgelr cr7)
1:	
	__(addi imm1,imm1,fixnum_one)
	__(cmpr(cr0,imm1,imm0))
	__(vpush(imm4))
	__(bne cr0,1b)
	__(blr)
	
/* Indicate whether &optional arguments were actually supplied.  nargs 
   contains the actual arg count (minus the number of required args); 
   imm0 contains the number of &optional args in the lambda list. 
   Note that nargs may be > imm0 if &rest/&key is involved. */
_spentry(opt_supplied_p)
	__(li imm1,0)
1:
	/* (vpush (< imm1 nargs)) */
	__(xor imm2,imm1,nargs)
	__(srawi imm2,imm2,31)
	__(or imm2,imm2,imm1)
	__(addi imm1,imm1,fixnumone)
	__(cmpr(cr0,imm1,imm0))
	__(subf imm2,nargs,imm2)
	__(srwi imm2,imm2,31)
	__(insrwi imm2,imm2,1,27)
	__(addi imm2,imm2,nil_value)
	__(vpush(imm2))
	__(bne cr0,1b)
	__(blr)
	


/* If nargs is <= imm0, vpush a nil.  Otherwise, cons a list of length 
   (- nargs imm0) and vpush it. 
   Use this entry point to heap-cons a simple &rest arg. */
_spentry(heap_rest_arg)
	__(li imm0,0)
	__(vpush_argregs())
 	__(sub imm1,nargs,imm0)
	__(cmpri(imm1,0))
	__(li arg_z,nil_value)
	__(b 2f)
1:
	__(ldr(temp0,0(vsp)))
	__(cmpri(imm1,fixnum_one))
	__(la vsp,4(vsp))
	__(Cons(arg_z,temp0,arg_z))
	__(subi imm1,imm1,fixnum_one)
2:
	__(bgt 1b)
	__(vpush(arg_z))
	__(blr)

	
/* And this entry point when the argument registers haven't yet been 
   vpushed (as is typically the case when required/&rest but no &optional/&key.) */
_spentry(req_heap_rest_arg)
	__(vpush_argregs())
 	__(sub imm1,nargs,imm0)
	__(cmpri(imm1,0))
	__(li arg_z,nil_value)
	__(b 2f)
1:
	__(ldr(temp0,0(vsp)))
	__(cmpri(imm1,fixnum_one))
	__(la vsp,4(vsp))
	__(Cons(arg_z,temp0,arg_z))
	__(subi imm1,imm1,fixnum_one)
2:
	__(bgt 1b)
	__(vpush(arg_z))
	__(blr)


_spentry(heap_cons_rest_arg)
 	__(sub imm1,nargs,imm0)
	__(cmpri(imm1,0))
	__(li arg_z,nil_value)
	__(b 2f)
1:
	__(ldr(temp0,0(vsp)))
	__(cmpri(imm1,fixnum_one))
	__(la vsp,4(vsp))
	__(Cons(arg_z,temp0,arg_z))
	__(subi imm1,imm1,fixnum_one)
2:
	__(bgt 1b)
	__(vpush(arg_z))
	__(blr)

	
_spentry(simple_keywords)
	__(li imm0,0)
        __(vpush_argregs())
        __(xjmp(keyword_bind))
                
_spentry(keyword_args)
	__(vpush_argregs())
        __(xjmp(keyword_bind))

_spentryX(keyword_bind)

_spentryX(ffcall)

_spentry(ffcalladdress)
        __(b _SPbreakpoint)
	
/* Signal an error synchronously, via %ERR-DISP. */
/* If %ERR-DISP isn't fbound, it'd be nice to print a message */
/* on the C runtime stderr. */

_spentry(ksignalerr)
	__(li fname,nrs.errdisp)
	__(jump_fname)
        
/* As in the heap-consed cases, only stack-cons the &rest arg */
_spentry(stack_rest_arg)
	__(li imm0,0)
	__(vpush_argregs())
        __(xjmp(stack_cons_rest_arg))

	
_spentry(req_stack_rest_arg)
	__(vpush_argregs())
        __(xjmp(stack_cons_rest_arg))
	
_spentryX(stack_cons_rest_arg)


_spentryX(callbackX)        
	
_spentryX(call_closure)        
        
_spentryX(getxlong)
        
_spentryX(spreadargz)

        
/* Tail-recursively funcall temp0. */
	/* Pretty much the same as the tcallsym* cases above. */
_spentry(tfuncallgen)
	__(cmpri(cr0,nargs,nargregs<<fixnumshift))
	__(ble cr0,_SPtfuncallvsp)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(imm0,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
	/* can use nfn (= temp2) as a temporary */
	__(subi imm1,nargs,nargregs<<fixnumshift)
	__(add imm1,imm1,vsp)
1:
	__(lwzu temp2,-4(imm1))
	__(cmpr(cr0,imm1,vsp))
	__(push(temp2,imm0))
	__(bne cr0,1b)
	__(mr vsp,imm0)
	__(do_funcall())


	/* Some args were vpushed.  Slide them down to the base of */
	/* the current frame, then do funcall. */
_spentry(tfuncallslide)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(imm0,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
	/* can use nfn (= temp2) as a temporary */
	__(subi imm1,nargs,nargregs<<fixnumshift)
	__(add imm1,imm1,vsp)
1:
	__(lwzu temp2,-4(imm1))
	__(cmpr(cr0,imm1,vsp))
	__(push(temp2,imm0))
	__(bne cr0,1b)
	__(mr vsp,imm0)
	__(do_funcall())

	/* No args were vpushed; recover saved context & do funcall */
_spentry(tfuncallvsp)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(mtlr loc_pc)
	__(discard_lisp_frame())
	__(do_funcall())
        
/* Tail-recursively call the (known symbol) in fname. */
/* In the general case, we don't know if any args were */
/* vpushed or not.  If so, we have to "slide" them down */
/* to the base of the frame.  If not, we can just restore */
/* vsp, lr, fn from the saved lisp frame on the control stack. */
_spentry(tcallsymgen)
	__(cmpri(cr0,nargs,nargregs<<fixnumshift))
	__(ble cr0,_SPtcallsymvsp)
        __(b _SPtcallsymslide)
	
/* Some args were vpushed.  Slide them down to the base of */
/* the current frame, then do funcall. */
_spentry(tcallsymslide)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(imm0,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
	/* can use nfn (= temp2) as a temporary */
	__(subi imm1,nargs,nargregs<<fixnumshift)
	__(add imm1,imm1,vsp)
1:
	__(lwzu temp2,-4(imm1))
	__(cmpr(cr0,imm1,vsp))
	__(push(temp2,imm0))
	__(bne cr0,1b)
	__(mr vsp,imm0)
	__(jump_fname)

/* No args were vpushed; recover saved context & call symbol */
_spentry(tcallsymvsp)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
	__(jump_fname)
	
/* Tail-recursively call the function in nfn. */
	/* Pretty much the same as the tcallsym* cases above. */
_spentry(tcallnfngen)
	__(cmpri(cr0,nargs,nargregs<<fixnumshift))
	__(ble cr0,_SPtcallnfnvsp)
        __(b _SPtcallnfnslide)

/* Some args were vpushed.  Slide them down to the base of */
/* the current frame, then do funcall. */
_spentry(tcallnfnslide)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(imm0,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
	/* Since we have a known function, can use fname as a temporary. */
	__(subi imm1,nargs,nargregs<<fixnumshift)
	__(add imm1,imm1,vsp)
1:
	__(lwzu fname,-4(imm1))
	__(cmpr(cr0,imm1,vsp))
	__(push(fname,imm0))
	__(bne cr0,1b)
	__(mr vsp,imm0)
       	__(jump_nfn())
        
_spentry(tcallnfnvsp)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(discard_lisp_frame())
	__(mtlr loc_pc)
       	__(jump_nfn())
	
_spentry(misc_ref)
	__(trap_unless_fulltag_equal(arg_y,fulltag_misc,imm0))
	__(trap_unless_lisptag_equal(arg_z,tag_fixnum,imm0))
	__(vector_length(imm0,arg_y,imm1))
	__(trlge(arg_z,imm0))
	__(extract_lowbyte(imm1,imm1))	/* imm1 = subtag */
        __(xjmp(misc_ref_common))	
	
/* misc_set (vector index newval).  Pretty damned similar to 
   misc_ref, as one might imagine. 
*/
_spentry(misc_set)
	__(trap_unless_fulltag_equal(arg_x,fulltag_misc,imm0))
	__(trap_unless_lisptag_equal(arg_y,tag_fixnum,imm0))
	__(vector_length(imm0,arg_x,imm1))
	__(trlge(arg_y,imm0))
	__(extract_lowbyte(imm1,imm1))
        __(xjmp(misc_set_common))
	
/* Make a cons cell on the vstack.  Always push 3 words, 'cause we're  
   not sure how the vstack will be aligned. */
_spentry(stkconsyz)
	__(li imm0,nil_value)
	__(vpush(imm0))
	__(vpush(imm0))
	__(vpush(imm0))
	__(andi. imm0,vsp,1<<2) /* (oddp vsp ?) */
	__(beq cr0,1f)
	__(str(arg_y,8(vsp))) /* car */
	__(str(arg_z,4(vsp))) /* cdr */
	__(la arg_z,fulltag_cons+4(vsp))
	__(blr)
1:
	__(str(arg_y,4(vsp))) /* car, again */
	__(str(arg_z,0(vsp)))
	__(la arg_z,fulltag_cons(vsp))
	__(blr)

/* Make a stack-consed value cell.  Much like the case of
   stack-allocating a cons cell.  Imm0 points to the closed-over value
   (already vpushed).  Replace that locative with the vcell. */
_spentry(stkvcell0)
	__(sub imm1,imm0,vsp) /* imm1 = delta from vsp to value cell loc */
	__(li arg_z,nil_value)
	__(vpush(arg_z))
	__(vpush(arg_z))
	__(vpush(arg_z))
	__(addi imm1,imm1,12)
	__(add imm0,vsp,imm1) /* in case stack overflowed */
	__(andi. imm1,vsp,1<<2) /* (oddp vsp) ? */
	__(li imm1,value_cell_header)
	__(ldr(arg_z,0(imm0)))
	__(beq cr0,1f)
	__(str(arg_z,8(vsp)))
	__(str(imm1,4(vsp)))
	__(la arg_z,fulltag_misc+4(vsp))
	__(str(arg_z,0(imm0)))
	__(blr)
1:
	__(str(arg_z,4(vsp)))
	__(str(imm1,0(vsp)))
	__(la arg_z,fulltag_misc(vsp))
	__(str(arg_z,0(imm0)))
	__(blr)

        
_spentry(stkvcellvsp)      
	__(li arg_z,nil_value)
	__(vpush(arg_z))
	__(vpush(arg_z))
	__(vpush(arg_z))
	__(li imm1,12)
	__(add imm0,vsp,imm1) /* in case stack overflowed */
	__(andi. imm1,vsp,1<<2) /* (oddp vsp) ? */
	__(li imm1,value_cell_header)
	__(ldr(arg_z,0(imm0)))
	__(beq cr0,1f)
	__(str(arg_z,8(vsp)))
	__(str(imm1,4(vsp)))
	__(la arg_z,fulltag_misc+4(vsp))
	__(str(arg_z,0(imm0)))
	__(blr)
1:
	__(str(arg_z,4(vsp)))
	__(str(imm1,0(vsp)))
	__(la arg_z,fulltag_misc(vsp))
	__(str(arg_z,0(imm0)))
	__(blr)

/* Make a "raw" area on the temp stack, stack-cons a macptr to point to it, 
   and return the macptr.  Size (in bytes, boxed) is in arg_z on entry; macptr in 
   arg_z on exit. 
   It would be nice to cons in the Mac heap if there's not room on 
   the tstack. This code will handle a new tstack segment being added. */
_spentry(makestackblock)
	__(unbox_fixnum(imm0,arg_z))
        __(dnode_align(imm0,imm0,tsp_frame.fixed_overhead+macptr.size))
	__(cmplri(cr0,imm0,tstack_alloc_limit))
	__(bge cr0,1f)
	__(TSP_Alloc_Var_Unboxed(imm0))
	__(li imm0,macptr_header)
	__(la imm1,tsp_frame.data_offset+macptr.size(tsp))
	__(str(imm0,tsp_frame.data_offset(tsp)))
	__(la arg_z,tsp_frame.data_offset+fulltag_misc(tsp))
	__(str(imm1,macptr.address(arg_z))) 
	__(blr)

/* Too big. Heap cons a gcable macptr */
1:
	__(TSP_Alloc_Fixed_Unboxed(0))
	__(set_nargs(1))
	__(li fname,nrs.new_gcable_ptr)
	__(jump_fname())

/* As above, only set the block's contents to 0. */
_spentry(makestackblock0)
	__(unbox_fixnum(imm0,arg_z))
        __(dnode_align(imm0,imm0,tsp_frame.fixed_overhead+macptr.size))
	__(cmplri(cr0,imm0,tstack_alloc_limit))
	__(bge cr0,3f)
	__(TSP_Alloc_Var_Unboxed(imm0))
	__(Zero_TSP_Frame(imm0,imm1))
	__(li imm0,macptr_header)
	__(la imm1,tsp_frame.data_offset+macptr.size(tsp))
	__(str(imm0,tsp_frame.data_offset(tsp)))
	__(la arg_z,tsp_frame.data_offset+fulltag_misc(tsp))
	__(str(imm1,macptr.address(arg_z))) /* makestackblock0 expects the address to be in imm1 */
	__(blr)

/* Too big. Heap cons a gcable macptr */
3:
	__(TSP_Alloc_Fixed_Unboxed(0)) /* "raw" block to make the compiler happy */

	__(mr arg_y,arg_z) /* save block size */
	__(li arg_z,t_value) /* clear-p arg to %new-gcable-ptr */
	__(set_nargs(2))
	__(li fname,nrs.new_gcable_ptr)
	__(jump_fname())

_spentryX(makestacklist)

/* subtype (boxed) vpushed before initial values. (Had better be a 
	node header subtag.) Nargs set to count of things vpushed. */

_spentry(stkgvector)
	__(la imm0,-4(nargs))
	__(cmpri(cr1,imm0,0))
	__(add imm1,vsp,nargs)
	__(lwzu temp0,-4(imm1))
	__(slwi imm2,imm0,num_subtag_bits-fixnumshift)
	__(rlwimi imm2,temp0,32-fixnumshift,32-num_subtag_bits,31)
        __(dnode_align(imm0,imm0,node_size+tsp_frame.fixed_overhead))
	__(TSP_Alloc_Var_Boxed_nz(imm0,imm3))
	__(str(imm2,tsp_frame.data_offset(tsp)))
	__(la arg_z,tsp_frame.data_offset+fulltag_misc(tsp))
	__(la imm3,misc_header_offset(arg_z))
	__(li imm0,fixnum1)
	__(b 2f)
1:
	__(addi imm0,imm0,fixnum1)
	__(cmpr(cr1,imm0,nargs))
	__(lwzu temp0,-4(imm1))
	__(stwu temp0,4(imm3))
2:
	__(bne cr1,1b)
	__(add vsp,vsp,nargs)
	__(blr)

/* Allocate a "fulltag_misc" object.  On entry, arg_y contains the element */
/* count (boxed) and  arg_z contains the subtag (boxed).  Both of these  */
/* parameters must be "reasonable" (the  subtag must be valid, the element */
/* count must be of type (unsigned-byte 24).  */
/* On exit, arg_z contains the (properly tagged) misc object; it'll have a */
/* proper header on it and its contents will be 0.   imm0 contains  */
/* the object's header (fulltag = fulltag_immheader or fulltag_nodeheader.) */
/* This is intended for things like "make-array" and "%make-bignum" and the  */
/* like.  Things that involve creating small objects of known size can usually */
/* do so inline with less hair. */

/* If this has to go out-of-line (to GC or whatever), it should do so via a  */
/* trap (or should otherwise ensure that both the LR and CTR are preserved  */
/* where the GC can find them.) */


_spentry(misc_alloc)
	__(extract_unsigned_byte_bits_(imm2,arg_y,24))
	__(unbox_fixnum(imm0,arg_z))
	__(extract_fulltag(imm1,imm0))
	__(bne- cr0,9f)
	__(cmpri(cr0,imm1,fulltag_nodeheader))
	__(mr imm3,imm0)
	__(cmplri(cr1,imm0,max_32_bit_ivector_subtag))
	__(rlwimi imm0,arg_y,num_subtag_bits-fixnum_shift,0,31-num_subtag_bits	/* imm0 now = header */)
	__(mr imm2,arg_y)
	__(beq cr0,1f)	/* do probe if node object (fixnum element count = byte count). */
	__(cmplri(cr0,imm3,max_16_bit_ivector_subtag))
	__(bng cr1,1f)	/* do probe if 32-bit imm object */
	__(cmplri(cr1,imm3,max_8_bit_ivector_subtag))
	__(srwi imm2,imm2,1)
	__(bgt cr0,2f)
	__(bgt cr1,1f)
	__(srwi imm2,imm2,1)
/* imm2 now = byte count.  Add 4 for header, 7 to align, then clear low three bits. */
1:
        __(dnode_align(imm2,imm2,node_size))

	__(Misc_Alloc(arg_z,imm0,imm2))
	__(blr)
2:
	__(cmplri(imm3,subtag_double_float_vector))
	__(slwi imm2,arg_y,1)
	__(beq 1b)
	__(addi imm2,arg_y,7<<fixnumshift)
	__(srwi imm2,imm2,fixnumshift+3)
	__(b 1b)
9:
	__(uuo_interr(error_object_not_unsigned_byte_24,arg_y))
        
_spentryX(ffcallX)
        
/* Bind special symbol in arg_z to its current value. */
_spentry(bind_self_boundp_check)
	__(ldr(imm0,symbol.flags(arg_z)))
	__(andi. imm0,imm0,sym_vbit_bound_mask)
	__(mr arg_y,arg_z)
	__(ldr(imm2,tcr.db_link(rcontext)))
	__(cmpri(cr1,imm2,0))
	__(beq 8f)
	__(b 1f)
0:	__(mr imm1,imm2)
	__(ldr(temp0,4(imm1)))
	__(cmpr(temp0,arg_y))
	__(ldr(imm2,0(imm1)))
	__(cmpri(cr1,imm2,0))
	__(bne 1f)
	__(ldr(arg_z,8(imm1)))
	__(b 9f)
1:	__(bne cr1,0b)
8:	__(ldr(arg_z,symbol.vcell(arg_y)))
9:	__(treqi(arg_z,unbound_marker))
	__(ldr(imm0,symbol.flags(arg_y)))
	__(ori imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm1,tcr.db_link(rcontext)))
	__(vpush(arg_z))
	__(vpush(arg_y))
	__(vpush(imm1))
	__(str(vsp,tcr.db_link(rcontext)))
	__(str(imm0,symbol.flags(arg_y)))
	__(blr)

/* Destructuring-bind, macro-bind. 
   */
/* OK to use arg_x, arg_y for whatever (tagged) purpose; 
   likewise immX regs. 
   arg_z preserved, nothing else in particular defined on exit. 
   nargs contains req count (0-255) in PPC bits mask_req_start/mask_req_width, 
                  opt count (0-255) in PPC bits mask_opt_start/mask_opt_width, 
                  key count (0-255) in PPC bits mask_key_start/mask_key_width, 
                  opt-supplied-p flag in PPC bit mask_initopt, 
                  keyp flag in PPC bit mask_keyp, 
                  &allow-other-keys flag in PPC bit mask_aok, 
   		   &rest flag in PPC bit mask_restp. 
   When mask_keyp bit is set, keyvect contains vector of keyword symbols, 
	length key count. */

_spentry(macro_bind)
	__(mr whole_reg,arg_reg)
	__(extract_lisptag(imm0,arg_reg))
	__(cmpri(cr0,imm0,tag_list))
	__(bne- cr0,1f)
	__(_cdr(arg_reg,arg_reg))
	__(xjmp(destbind1))
1:
	__(li arg_y,XCALLNOMATCH)
	__(mr arg_z,whole_reg)
	__(set_nargs(2))
	__(b _SPksignalerr)


_spentry(destructuring_bind)
	__(mr whole_reg,arg_reg)
        __(xjmp(destbind1))
	
_spentry(destructuring_bind_inner)
	__(mr whole_reg,arg_z)
	__(xjmp(destbind1))

	
/* vpush the values in the value set atop the vsp, incrementing nargs. */
/* Discard the tsp frame; leave values atop the vsp. */

_spentry(recover_values)

/* First, walk the segments reversing the pointer to previous segment pointers */
/* Can tell the end because that previous segment pointer is the prev tsp pointer */
	__(ldr(imm0,tsp_frame.backlink(tsp))) /* previous tsp */
	__(mr imm1,tsp) /* current segment */
	__(mr imm2,tsp) /* last segment */
local_label(walkloop):
	__(ldr(imm3,12(imm1))) /* next segment */
	__(cmpr(cr0,imm0,imm3)) /* last segment? */
	__(str(imm2,12(imm1))) /* reverse pointer */
	__(mr imm2,imm1) /* last segment <- current segment */
	__(mr imm1,imm3) /* current segment <- next segment */
	__(bne cr0,local_label(walkloop))

/* the final segment ptr is now in imm2 */
/* walk backwards, pushing values on VSP and incrementing NARGS */
local_label(pushloop):
	__(ldr(imm0,8(imm2))) /* nargs in segment */
	__(cmpri(cr0,imm0,0))
	__(cmpr(cr1,imm2,tsp))
	__(la imm3,16(imm2))
	__(add imm3,imm3,imm0)
	__(add nargs,nargs,imm0)
	__(b 2f)
1:
	__(lwzu arg_z,-4(imm3))
	__(cmpri(cr0,imm0,fixnum_one))
	__(subi imm0,imm0,fixnum_one)
	__(vpush(arg_z))
2:
	__(bne cr0,1b)
	__(ldr(imm2,12(imm2))) /* previous segment */
	__(bne cr1,local_label(pushloop))
	__(unlink(tsp))
	__(blr)

	
/* Go out of line to do this.  Sheesh. */

_spentry(vpopargregs)
	__(cmpri(cr0,nargs,0))
	__(cmpri(cr1,nargs,2<<fixnumshift))
	__(beqlr cr0)
	__(beq cr1,local_label(yz))
	__(blt cr1,local_label(z))
	__(ldr(arg_z,0(vsp)))
	__(ldr(arg_y,4(vsp)))
	__(ldr(arg_x,8(vsp)))
	__(la vsp,12(vsp))
	__(blr)
local_label(yz):
	__(ldr(arg_z,0(vsp)))
	__(ldr(arg_y,4(vsp)))
	__(la vsp,8(vsp))
	__(blr)
local_label(z):
	__(ldr(arg_z,0(vsp)))
	__(la vsp,4(vsp))
	__(blr)

/* If arg_z is an integer, return in imm0 something whose sign */
/* is the same as arg_z's.  If not an integer, error. */
_spentry(integer_sign)
	__(extract_typecode(imm0,arg_z))
	__(cmpri(cr1,imm0,tag_fixnum))
	__(cmpri(cr0,imm0,subtag_bignum))
	__(mr imm0,arg_z)
	__(beqlr+ cr1)
	__(bne- cr0,1f)
	__(getvheader(imm0,arg_z))
	__(header_length(imm0,imm0)) /* boxed length = scaled size */
	__(addi imm0,imm0,misc_data_offset-4) /* bias, less 1 element */
	__(ldrx(imm0,arg_z,imm0))
	__(cmpri(cr0,imm0,0))
	__(li imm0,1)
	__(bgelr cr0)
	__(li imm0,-1)
	__(blr)
1:
	__(uuo_interr(error_object_not_integer,arg_z))

/* like misc_set, only pass the (boxed) subtag in temp0 */
_spentry(subtag_misc_set)
	__(trap_unless_fulltag_equal(arg_x,fulltag_misc,imm0))
	__(trap_unless_lisptag_equal(arg_y,tag_fixnum,imm0))
	__(vector_length(imm0,arg_x,imm1))
	__(trlge(arg_y,imm0))
	__(unbox_fixnum(imm1,temp0))
	__(xjmp(misc_set_common))

_spentryX(spread_lexprz)
        
/* Set the special variable in arg_y to the value in arg_z. 
   Error if arg_y is a constant. 
   arg_y is a known, non-nil symbol. */
_spentry(setqsym)
	__(ldr(imm0,symbol.flags(arg_y)))
	__(andi. imm0,imm0,sym_vbit_const_mask)
	__(beq _SPspecset)
	__(mr arg_z,arg_y)
	__(lwi(arg_y,XCONST))
	__(set_nargs(2))
	__(b _SPksignalerr)
		
_spentry(reset)
	.globl _SPthrow
	__(nop)
	__(ref_nrs_value(temp0,toplcatch))
	__(li temp1,XSTKOVER)
	__(vpush(temp0))
	__(vpush(temp1))
	__(set_nargs(1))
	__(b _SPthrow)

	
/* "slide" nargs worth of values up the vstack.  IMM0 contains */
/* the difference between the current VSP and the target. */
_spentry(mvslide)
	__(cmpri(cr0,nargs,0))
	__(mr imm3,nargs)
	__(add imm2,vsp,nargs)
	__(add imm2,imm2,imm0)
	__(add imm0,vsp,nargs)
	__(beq 2f)
1:
	__(cmpri(cr0,imm3,1<<fixnumshift))
	__(subi imm3,imm3,1<<fixnumshift)
	__(lwzu temp0,-4(imm0))
	__(stwu temp0,-4(imm2))
	__(bne cr0,1b)
2:
	__(mr vsp,imm2)
	__(blr)

/* Build a new TSP area to hold nargs worth of multiple-values. */
/* Pop the multiple values off of the vstack. */
/* The new TSP frame will look like this: */
/* 
+--------+-------+-------+---------+--------+--------+--------+======+----------+
| ptr to | zero  | nargs | ptr to  | valn-1 | valn-2 | val-0  | ???? | prev TSP | 
|  prev  |       |       |  prev   |        |        |        | fill |          | 
| TSP    |       |       | segment |        |        |        |      |          |
+--------+-------+-------+---------+--------+--------+--------+------+----------+ 
 */
/* e.g., the first multiple value goes in the last cell in the frame, the */
/* count of values goes in the first word, and the word after the value count */
/* is 0 if the number of values is even (for alignment). */
/* Subsequent calls to .SPadd_values preserve this alignment. */
/* .SPrecover_values is therefore pretty simple. */

_spentry(save_values)
	__(mr imm1,tsp)

/* common exit: nargs = values in this set, imm1 = ptr to tsp before call to save_values */
local_label(save_values_to_tsp):
	__(mr imm2,tsp)
	__(dnode_align(imm0,nargs,tsp_frame.fixed_overhead+8)) /* count, link */
	__(TSP_Alloc_Var_Boxed_nz(imm0,imm3))
	__(str(imm1,tsp_frame.backlink(tsp))) /* keep one tsp "frame" as far as rest of lisp is concerned */
	__(str(nargs,tsp_frame.data_offset(tsp)))
	__(str(imm2,tsp_frame.data_offset+4(tsp))) /* previous tsp */
	__(la imm3,tsp_frame.data_offset+8(tsp))
	__(add imm3,imm3,nargs)
	__(add imm0,vsp,nargs)
	__(cmpr(cr0,imm0,vsp))
	__(b 2f)
1:
	__(lwzu arg_z,-4(imm0))
	__(cmpr(cr0,imm0,vsp))
	__(stwu arg_z,-4(imm3))
2:
	__(bne cr0,1b)
	__(add vsp,vsp,nargs) /*  discard values */
	__(blr)
	

/* Add the multiple values that are on top of the vstack to the set */
/* saved in the top tsp frame, popping them off of the vstack in the */
/* process.  It is an error (a bad one) if the TSP contains something */
/* other than a previously saved set of multiple-values. */
/* Since adding to the TSP may cause a new TSP segment to be allocated, */
/* each add_values call adds another linked element to the list of */
/* values. This makes recover_values harder. */

_spentry(add_values)
	__(cmpri(cr0,nargs,0))
	__(ldr(imm1,0(tsp)))
	__(bne cr0,local_label(save_values_to_tsp))
	__(blr)
        
_spentryX(callback)
        
/* Like misc_alloc (a LOT like it, since it does most of the work), but takes */
/* an initial-value arg in arg_z, element_count in arg_x, subtag in arg_y. */
/* Calls out to %init-misc, which does the rest of the work. */

_spentry(misc_alloc_init)
	__(mflr loc_pc)
	__(create_lisp_frame())
	__(str(fn,lisp_frame.savefn(sp)))
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(vsp,lisp_frame.savevsp(sp)))
	__(li fn,0)
	__(mr temp0,arg_z)		/* initval */
	__(mr arg_z,arg_y)		/* subtag */
	__(mr arg_y,arg_x)		/* element-count */
	__(bl _SPmisc_alloc)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(mtlr loc_pc)
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp))) /* vsp may have moved to the bottom of a new stack segment */
	__(discard_lisp_frame())
	__(li fname,nrs.init_misc)
	__(set_nargs(2))
	__(mr arg_y,temp0)
	__(jump_fname())

/* As in stack_misc_alloc above, only with a non-default initial-value. */

_spentry(stack_misc_alloc_init)
	__(mflr loc_pc)
	__(create_lisp_frame())
	__(str(fn,lisp_frame.savefn(sp)))
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(vsp,lisp_frame.savevsp(sp)))
	__(li fn,0)
	__(mr temp0,arg_z) /* initval */
	__(mr arg_z,arg_y) /* subtag */
	__(mr arg_y,arg_x) /* element-count */
	__(bl stack_misc_alloc)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(mtlr loc_pc)
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp))) /* vsp may have changed due to overflowing a stack segment */
	__(discard_lisp_frame())
	__(li fname,nrs.init_misc)
	__(set_nargs(2))
	__(mr arg_y,temp0)
	__(jump_fname())

_spentryX(progvsave)
	
/*
   Restore the special bindings from the top of the tstack, 
   leaving the tstack frame allocated. 
   Note that there might be 0 saved bindings, in which case 
   do nothing. 
   Note also that this is -only- called from an unwind-protect 
   cleanup form, and that .SPnthrowXXX is keeping one or more 
   values in a frame on top of the tstack. 
*/
	
_spentry(progvrestore)
	__(ldr(imm0,tsp_frame.backlink(tsp)))	/* ignore .SPnthrowXXX values frame */
	__(ldr(imm0,tsp_frame.data_offset(imm0)))
	__(cmpri(cr0,imm0,0))
	__(unbox_fixnum(imm0,imm0))
	__(bne+ cr0,_SPunbind_n)
	__(blr)

_spentry(callbuiltin)
	__(ref_nrs_value(fname,builtin_functions))
	__(la imm0,misc_data_offset(imm0))
	__(ldrx(fname,fname,imm0))
	__(jump_fname())

/* the value of the nilreg-relative symbol %builtin-functions% should be */
/* a vector of symbols.  Call the symbol indexed by imm0 (boxed) and */
/* return a single value. */

_spentry(callbuiltin0)
	__(set_nargs(0))
	__(ref_nrs_value(fname,builtin_functions))
	__(la imm0,misc_data_offset(imm0))
	__(ldrx(fname,fname,imm0))
	__(jump_fname())

_spentry(callbuiltin1)
	__(set_nargs(1))
	__(ref_nrs_value(fname,builtin_functions))
	__(la imm0,misc_data_offset(imm0))
	__(ldrx(fname,fname,imm0))
	__(jump_fname())

_spentry(callbuiltin2)
	__(set_nargs(2))
	__(ref_nrs_value(fname,builtin_functions))
	__(la imm0,misc_data_offset(imm0))
	__(ldrx(fname,fname,imm0))
	__(jump_fname())


_spentry(callbuiltin3)
	__(set_nargs(3))
	__(ref_nrs_value(fname,builtin_functions))
	__(la imm0,misc_data_offset(imm0))
	__(ldrx(fname,fname,imm0))
	__(jump_fname())
	

_spentry(popj)
	.globl C(popj)
C(popj):
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(mtlr loc_pc)
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(discard_lisp_frame())
	__(blr)

_spentry(restorefullcontext)
	__(mflr loc_pc)
	__(mtctr loc_pc)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(mtlr loc_pc)
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(discard_lisp_frame())
	__(bctr)

_spentry(savecontextvsp)
	__(create_lisp_frame())
	__(str(fn,lisp_frame.savefn(sp)))
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(vsp,lisp_frame.savevsp(sp)))
	__(mr fn,nfn)
	__(ldr(imm0,tcr.cs_limit(rcontext)))
	__(trllt(sp,imm0))
	__(blr)

_spentry(savecontext0)
	__(create_lisp_frame())
	__(add imm0,vsp,imm0)
	__(str(fn,lisp_frame.savefn(sp)))
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(imm0,lisp_frame.savevsp(sp)))
	__(mr fn,nfn)
	__(ldr(imm0,tcr.cs_limit(rcontext)))
	__(trllt(sp,imm0))
	__(blr)


/* Like .SPrestorefullcontext, only the saved return address */
/* winds up in loc-pc instead of getting thrashed around ... */
_spentry(restorecontext)
	__(ldr(loc_pc,lisp_frame.savelr(sp)))
	__(ldr(vsp,lisp_frame.savevsp(sp)))
	__(ldr(fn,lisp_frame.savefn(sp)))
	__(discard_lisp_frame())
	__(blr)

        
/* Nargs is valid; all arg regs, lexpr-count pushed by caller. */
/* imm0 = vsp to restore. */
/* Return all values returned by caller to its caller, hiding */
/* the variable-length arglist. */
/* If we can detect that the caller's caller didn't expect */
/* multiple values, then things are even simpler. */
_spentry(lexpr_entry)
	__(ref_global(imm1,ret1val_addr))
	__(cmpr(cr0,imm1,loc_pc))
	__(create_lisp_frame())
	__(str(fn,lisp_frame.savefn(sp)))
	__(str(loc_pc,lisp_frame.savelr(sp)))
	__(str(imm0,lisp_frame.savevsp(sp)))
	__(bne cr0,1f)
	__(ref_global(imm0,lexpr_return))
	__(create_lisp_frame())
	__(str(rzero,lisp_frame.savefn(sp)))
	__(str(imm0,lisp_frame.savelr(sp)))
	__(str(vsp,lisp_frame.savevsp(sp)))
	__(mr loc_pc,imm1)
	__(ldr(imm0,tcr.cs_limit(rcontext)))
	__(trllt(sp,imm0))
	__(li fn,0)
	__(blr)

/* The single-value case just needs to return to something that'll pop */
/* the variable-length frame off of the vstack. */
1:
	__(ref_global(loc_pc,lexpr_return1v))
	__(ldr(imm0,tcr.cs_limit(rcontext)))
	__(trllt(sp,imm0))
	__(li fn,0)
	__(blr)

_spentryX(darwin_syscall)
        
_spentry(builtin_plus)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- cr0,1f)
	__(mcrxr cr0)
	__(addo. arg_z,arg_y,arg_z)
	__(bnslr+)
	__(unbox_fixnum(imm1,arg_z))
	__(xoris imm1,imm1,0xc000)
	__(li imm0,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
1:
	__(jump_builtin(_builtin_plus,2))
_spentry(builtin_minus)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- cr0,1f)
	__(mcrxr cr0)
	__(subo. arg_z,arg_y,arg_z)
	__(bnslr+)
	__(unbox_fixnum(imm1,arg_z))
	__(xoris imm1,imm1,0xc000)
	__(li imm0,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
1:
	__(jump_builtin(_builtin_minus,2))
_spentry(builtin_times)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(unbox_fixnum(imm2,arg_y))
	__(bne 1f)
	__(mcrxr cr0)
	__(mullwo. imm3,arg_z,imm2)
	__(bso 2f)		/*  SO set if result would overflow a fixnum */
	__(mr arg_z,imm3)
	__(blr)
	/* Args are fixnums; result can't be */
2:	__(unbox_fixnum(imm3,arg_z))
	__(mullw imm1,imm3,imm2) /* imm1 = low  32 bits */
	__(mulhw imm0,imm3,imm2) /* imm0 = high 32 bits */
	__(b _SPmakes64)

1:	__(jump_builtin(_builtin_times,2))

_spentry(builtin_div)
	__(jump_builtin(_builtin_div,2))

_spentry(builtin_eq)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(bnelr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_eq,2))

_spentry(builtin_ne)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(beqlr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_ne,2))

_spentry(builtin_gt)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(bnglr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_gt,2))

_spentry(builtin_ge)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(bltlr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_ge,2))

_spentry(builtin_lt)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(bnllr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_lt,2))

_spentry(builtin_le)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(cmpr(cr1,arg_y,arg_z))
	__(bne- cr0,1f)
	__(li arg_z,nil_value)
	__(bgtlr cr1)
	__(li arg_z,t_value)
	__(blr)
1:
	__(jump_builtin(_builtin_le,2))


_spentry(builtin_eql)
	__(cmpr(cr0,arg_y,arg_z))
	__(extract_lisptag(imm0,arg_y))
	__(extract_lisptag(imm1,arg_z))
	__(cmpr(cr1,imm0,imm1))
	__(beq cr0,1f)
	__(cmpri(cr0,imm0,tag_misc))
	__(bne cr1,2f)
	__(bne cr0,2f)
	__(jump_builtin(_builtin_eql,2))
1:	__(li arg_z,t_value)
	__(blr)
2:	__(li arg_z,nil_value)
	__(blr)
        
_spentry(builtin_length)
	__(cmpri(cr1,arg_z,nil_value))
	__(extract_typecode(imm0,arg_z))
	__(cmpri(cr0,imm0,min_vector_subtag))
	__(beq cr1,1f)
	__(beq- cr0,2f)
	__(blt- cr0,3f)
	/* (simple-array * (*)) */
	__(vector_length(arg_z,arg_z,imm0))
	__(blr)
2:
	__(ldr(arg_z,vectorH.logsize(arg_z)))
	__(blr)
1:
	__(li arg_z,0)
	__(blr)
3:
	__(jump_builtin(_builtin_length,1))

_spentry(builtin_seqtype)
	__(extract_typecode(imm0,arg_z))
	__(cmpri(cr0,imm0,tag_list))
	__(cmpri(cr1,imm1,min_vector_subtag))
	__(beq cr0,1f)
	__(blt- cr1,2f)
	__(li arg_z,nil_value)
	__(blr)
1:	__(li arg_z,t_value)
	__(blr)
2:
	__(jump_builtin(_builtin_seqtype,1))
        
_spentry(builtin_assq)
	__(cmpri(arg_z,nil_value))
	__(beqlr)
1:	__(trap_unless_lisptag_equal(arg_z,tag_list,imm0))
	__(_car(arg_x,arg_z))
	__(_cdr(arg_z,arg_z))
	__(cmpri(cr2,arg_x,nil_value))
	__(cmpri(cr1,arg_z,nil_value))
	__(beq cr2,2f)
	__(trap_unless_lisptag_equal(arg_x,tag_list,imm0))
	__(_car(temp0,arg_x))
	__(cmpr(temp0,arg_y))
	__(bne 2f)
	__(mr arg_z,arg_x)
	__(blr)
2:	__(bne cr1,1b)
	__(blr)


_spentry(builtin_memq)
	__(cmpri(cr1,arg_z,nil_value))
	__(b 2f)
1:	__(trap_unless_lisptag_equal(arg_z,tag_list,imm0))
	__(_car(arg_x,arg_z))
	__(_cdr(temp0,arg_z))
	__(cmpr(arg_x,arg_y))
	__(cmpri(cr1,temp0,nil_value))
	__(beqlr)
	__(mr arg_z,temp0)
2:	__(bne cr1,1b)
	__(blr)


_spentry(builtin_logbitp)
	/* Call out unless both fixnums,0 <=  arg_y < 30 */
	__(cmplri(cr1,arg_y,30<<fixnum_shift))
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(unbox_fixnum(imm0,arg_y))
	__(subfic imm0,imm0,30)
	__(rlwnm imm0,arg_z,imm0,31,31)
	__(rlwimi imm0,imm0,4,27,27)
	__(bnl cr1,1f)
	__(bne cr0,1f)
	__(addi arg_z,imm0,nil_value)
	__(blr)
1:
	__(jump_builtin(_builtin_logbitp,2))

_spentry(builtin_logior)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- cr0,1f)
	__(or arg_z,arg_y,arg_z)
	__(blr)
1:
	__(jump_builtin(_builtin_logior,2))

_spentry(builtin_logand)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- cr0,1f)
	__(and arg_z,arg_y,arg_z)
	__(blr)
1:
	__(jump_builtin(_builtin_logand,2))
	
_spentry(builtin_ash)
	__(cmpri(cr1,arg_z,0))
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- 9f)
	__(bne cr1,0f)
	__(mr arg_z,arg_y)	/* (ash n 0) => n */
	__(blr)
0:		
	__(unbox_fixnum(imm1,arg_y))
	__(unbox_fixnum(imm0,arg_z))
	__(bgt cr1,1f)
	/* (ash n -count) => fixnum */
	__(neg imm0,imm0)
	__(sraw imm1,imm1,imm0)
	__(box_fixnum(arg_z,imm1))
	__(blr)
	/* Integer-length of arg_y/imm1 to imm2 */
1:		
	__(cntlzw. imm2,imm1)
	__(bne 2f)		/* cr0[eq] set if negative */
	__(not imm2,imm1)
	__(cntlzw imm2,imm2)
2:
	__(subfic imm2,imm2,32)
	__(add imm2,imm2,imm0)	 /* imm2 <- integer-length(imm1) + count */
	__(cmpri(cr1,imm2,31-fixnumshift))
	__(cmpri(cr2,imm0,32))
	__(slw imm2,imm1,imm0)
	__(bgt cr1,6f)
	__(box_fixnum(arg_z,imm2))
	__(blr)
6:
	__(bgt cr2,9f)
	__(bne cr2,7f)
	/* Shift left by 32 bits exactly */
	__(mr imm0,imm1)
	__(li imm1,0)
	__(beq _SPmakes64)
	__(b _SPmakeu64)
7:
	/* Shift left by fewer than 32 bits, result not a fixnum */
	__(subfic imm0,imm0,32)
	__(beq 8f)
	__(srw imm0,imm1,imm0)
	__(mr imm1,imm2)
	__(b _SPmakeu64)
8:	
	__(sraw imm0,imm1,imm0)
	__(mr imm1,imm2)
	__(b _SPmakes64)	
9:		
	__(jump_builtin(_builtin_ash,2))

_spentry(builtin_negate)
	__(extract_lisptag_(imm0,arg_z))
	__(bne- cr0,1f)
	__(mcrxr cr0)
	__(nego. arg_z,arg_z)
	__(bnslr+)
	__(unbox_fixnum(imm1,arg_z))
	__(xoris imm1,imm1,0xc000)
	__(li imm0,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
1:
	__(jump_builtin(_builtin_negate,1))

_spentry(builtin_logxor)
	__(extract_2_lisptags_(imm0,arg_y,arg_z))
	__(bne- cr0,1f)
	__(xor arg_z,arg_y,arg_z)
	__(blr)
1:
	__(jump_builtin(_builtin_logxor,2))


_spentry(builtin_aref1)
	.globl _SPsubtag_misc_ref
	__(extract_typecode(imm0,arg_y))
	__(cmpri(cr0,imm0,min_vector_subtag))
	__(box_fixnum(arg_x,imm0))
	__(bgt cr0,1f)
	__(jump_builtin(_builtin_aref1,2))
1:
	__(b _SPsubtag_misc_ref)

_spentry(builtin_aset1)
	__(extract_typecode(imm0,arg_x))
	__(cmpri(cr0,imm0,min_vector_subtag))
	__(box_fixnum(temp0,imm0))
	__(bgt cr0,1f)
	__(jump_builtin(_builtin_aset1,3))
1:
	__(b _SPsubtag_misc_set)

/* Enter the debugger */
_spentry(breakpoint)
	__(li r3,0)
	__(tw 28,sp,sp)	/* 28 = lt|gt|eq (assembler bug for the latter) */
	__(blr)		/* if handler didn't */

_spentryX(eabi_ff_call)
        
_spentryX(eabi_callback)
	
_spentryX(syscall)
        
/* arg_z should be of type (UNSIGNED-BYTE 64); return high 32 bits
	in imm0, low 32 bits in imm1 */

_spentry(getu64)
	__(extract_typecode(imm0,arg_z))
	__(cmpri(cr0,imm0,tag_fixnum))
	__(cmpri(cr1,arg_z,0))
	__(cmpri(cr2,imm0,subtag_bignum))
	__(unbox_fixnum(imm1,arg_z))
	__(bne cr0,8f)
	__(bgelr cr1)
9:
	__(uuo_interr(error_object_not_u64,arg_z))
8:
	__(bne- cr2,9b)
	__(getvheader(imm2,arg_z))
	__(cmpri(cr2,imm2,two_digit_bignum_header))
	__(vrefr(imm1,arg_z,0))
	__(cmpri(cr1,imm1,0))
	__(li imm0,0)
	__(bge cr2,2f)
	__(blt- cr1,9b)
	__(blr)
2:
	__(cmpri(cr0,imm2,three_digit_bignum_header))
	__(vrefr(imm0,arg_z,1))
	__(cmpri(cr1,imm0,0))
	__(bne cr2,3f)
	__(blt- cr1,9b)
	__(blr)
3:
	__(vrefr(imm2,arg_z,2))
	__(cmpri(cr1,imm2,0))
	__(bne- cr0,9b)
	__(bne- cr1,9b)
	__(blr)

/* arg_z should be of type (SIGNED-BYTE 64); return high 32 bits
	in imm0, low 32 bits in imm1 */

_spentry(gets64)
	__(extract_typecode(imm0,arg_z))
	__(cmpri(cr0,imm0,tag_fixnum))
	__(cmpri(cr2,imm0,subtag_bignum))
	__(unbox_fixnum(imm1,arg_z))
	__(srawi imm0,imm1,31)
	__(beqlr cr0)
	__(bne cr2,9f)
	__(getvheader(imm2,arg_z))
	__(cmpri(cr2,imm2,two_digit_bignum_header))
	__(vrefr(imm1,arg_z,0))
	__(srawi imm0,imm1,31)
	__(bltlr cr2)
	__(vrefr(imm0,arg_z,1))
	__(beqlr cr2)
9:
	__(uuo_interr(error_object_not_s64,arg_z))

/*
  Construct a lisp integer out of the 64-bit unsigned value in
  imm0 (high 32 bits) and imm1 (low 32 bits). */
_spentry(makeu64)
	__(cmpri(cr1,imm0,0))
	__(rlwinm. imm2,imm1,0,0,fixnum_shift)
	__(li imm2,three_digit_bignum_header)
	__(box_fixnum(arg_z,imm1))
	__(blt cr1,3f)
	__(bne cr1,2f)
	__(beqlr cr0) /* A fixnum */
	__(blt cr0,2f)
	__(li imm2,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm2,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
2:
	__(li imm2,two_digit_bignum_header)
3:
	__(Misc_Alloc_Fixed(arg_z,imm2,16))
	__(str(imm1,misc_data_offset(arg_z)))
	__(str(imm0,misc_data_offset+4(arg_z)))
	__(blr)


/*
  Construct a lisp integer out of the 64-bit signed value in
  imm0 (high 32 bits) and imm1 (low 32 bits). */
_spentry(makes64)
	__(srawi imm2,imm1,31)
	__(cmpr(cr1,imm2,imm0))
	__(mcrxr cr0)
	__(addo imm2,imm1,imm1)
	__(addo. arg_z,imm2,imm2)
	__(bne cr1,2f) /* High word is significant */
	__(li imm2,one_digit_bignum_header)
	__(bnslr cr0) /* No overflow:	 fixnum */
	__(Misc_Alloc_Fixed(arg_z,imm2,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
2:
	__(li imm2,two_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm2,16))
	__(str(imm1,misc_data_offset(arg_z)))
	__(str(imm0,misc_data_offset+4(arg_z)))
	__(blr)

/*
  arg_y must be a real, live symbol. On exit, arg_z might be an
  unbound_marker; any caller who cares should check for that.
*/
_spentry(specref)
	__(ldr(imm0,symbol.flags(arg_y)))
	__(andi. imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm2,tcr.db_link(rcontext)))
	__(cmpri(cr1,imm2,0))
	__(beq 9f)
	__(b 1f)
0:	__(mr imm1,imm2)
	__(ldr(temp0,4(imm1)))
	__(cmpr(temp0,arg_y))
	__(ldr(imm2,0(imm1)))
	__(cmpri(cr1,imm2,0))
	__(bne 1f)
	__(ldr(arg_z,8(imm1)))
	__(blr)
1:	__(bne cr1,0b)
9:	__(ldr(arg_z,symbol.vcell(arg_y)))
        __(li imm1,0)
	__(blr)

/*
  Likewise, arg_y must be a real symbol.
*/
_spentry(specset)
	__(ldr(imm0,symbol.flags(arg_y)))
	__(andi. imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm2,tcr.db_link(rcontext)))
	__(cmpri(cr1,imm2,0))
	__(beq 2f)
	__(b 1f)
0:	__(mr imm1,imm2)
	__(ldr(temp0,4(imm1)))
	__(cmpr(temp0,arg_y))
	__(ldr(imm2,0(imm1)))
	__(cmpri(cr1,imm2,0))
	__(bne 1f)
	__(str(arg_z,8(imm1)))
	__(blr)
1:	__(bne cr1,0b)
2:      __(str(arg_z,symbol.vcell(arg_y)))
	__(blr)

_spentry(specrefcheck)
	__(ldr(imm0,symbol.flags(arg_y)))
	__(andi. imm0,imm0,sym_vbit_bound_mask)
	__(ldr(imm2,tcr.db_link(rcontext)))
	__(cmpri(cr1,imm2,0))
	__(beq 8f)
	__(b 1f)
0:	__(mr imm1,imm2)
	__(ldr(temp0,4(imm1)))
	__(cmpr(temp0,arg_y))
	__(ldr(imm2,0(imm1)))
	__(cmpri(cr1,imm2,0))
	__(bne 1f)
	__(ldr(arg_z,8(imm1)))
	__(b 9f)
1:	__(bne cr1,0b)
8:	__(ldr(arg_z,symbol.vcell(arg_y)))
9:	__(treqi(arg_z,unbound_marker))
	__(blr)

	/* Restore current thread's interrupt level to arg_z,
	   noting whether the tcr's interrupt_pending flag was set. */
_spentry(restoreintlevel)
	__(cmpri(cr1,arg_z,0))
	__(ldr(imm0,tcr.interrupt_pending(rcontext)))
	__(cmpri(cr0,imm0,0))
	__(bne cr1,1f)
	__(beq cr0,1f)
	__(str(rzero,tcr.interrupt_pending(rcontext)))
	__(li nargs,fixnum_one)
	__(twgti nargs,0)
	__(blr)
1:	
	__(str(arg_z,tcr.interrupt_level(rcontext)))
	__(blr)

/*
  Construct a lisp integer out of the 32-bit signed value in imm0
 */
_spentry(makes32)
	__(mcrxr cr0)
	__(addo imm1,imm0,imm0)
	__(addo. arg_z,imm1,imm1)
	__(bnslr+)
	__(li imm1,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm1,node_size*2))
	__(str(imm0,misc_data_offset(arg_z)))
	__(blr)

/*
  Construct a lisp integer out of the 32-bit unsigned value in imm0
 */
_spentry(makeu32)
	__(clrrwi. imm1,imm0,31-nfixnumtagbits)
	__(cmpri(cr1,imm0,0))
	__(box_fixnum(arg_z,imm0))
	__(beqlr cr0) /* A fixnum */
	__(blt cr1,2f)
	__(li imm2,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm2,8))
	__(str(imm0,misc_data_offset(arg_z)))
	__(blr)
2:
	__(li imm2,two_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm2,16))
	__(str(imm0,misc_data_offset(arg_z)))
	__(blr)

/* 
  arg_z should be of type (SIGNED-BYTE 32); return unboxed result in imm0
*/
_spentry(gets32)
	__(extract_typecode(imm1,arg_z))
	__(cmpri(cr0,imm1,tag_fixnum))
	__(cmpri(cr2,imm1,subtag_bignum))
	__(unbox_fixnum(imm0,arg_z))
	__(beqlr+ cr0)
	__(bne cr2,9f)
	__(getvheader(imm1,arg_z))
	__(cmpri(cr1,imm1,one_digit_bignum_header))
	__(vrefr(imm0,arg_z,0))
	__(beqlr+ cr1)
9:
	__(uuo_interr(error_object_not_signed_byte_32,arg_z))

/* 
  arg_z should be of type (UNSIGNED-BYTE 32); return unboxed result in imm0
*/

_spentry(getu32)
	__(extract_typecode(imm1,arg_z))
	__(cmpri(cr0,imm1,tag_fixnum))
	__(cmpri(cr1,arg_z,0))
	__(cmpri(cr2,imm1,subtag_bignum))
	__(unbox_fixnum(imm0,arg_z))
	__(bne cr0,8f)
	__(bgelr cr1)
8:
	__(bne- cr2,9f)
	__(getvheader(imm2,arg_z))
	__(cmpri(cr2,imm2,two_digit_bignum_header))
	__(vrefr(imm0,arg_z,0))
	__(cmpri(cr0,imm0,0))
	__(bgt cr2,9f)
	__(beq cr2,2f)
	__(blt cr0,9f)
	__(blr)
2:
	__(vrefr(imm1,arg_z,1))
	__(cmpri(cr0,imm1,0))
	__(beqlr+ cr0)

9:
	__(uuo_interr(error_object_not_unsigned_byte_32,arg_z))

/*
  arg_z has overflowed (by one bit) as the result of an addition or subtraction.
  Make a bignum out of it.
*/
_spentry(fix_overflow)
	__(unbox_fixnum(imm1,arg_z))
	__(xoris imm1,imm1,0xc000)
	__(li imm0,one_digit_bignum_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,8))
	__(str(imm1,misc_data_offset(arg_z)))
	__(blr)
		

_spentry(consyz)
	__(Cons(arg_z,arg_y,arg_z))
	__(blr)

_spentry(makevcellz)
	__(li imm0,value_cell_header)
	__(la allocptr,(-8)+fulltag_misc(allocptr))
	__(trllt(allocptr,allocbase))
	__(str(imm0,misc_header_offset(allocptr)))
	__(str(arg_z,misc_data_offset(allocptr)))
	__(mr arg_z,allocptr)
	__(clear_alloc_tag())
	__(blr)

_spentry(makedouble)
	__(li imm0,double_float_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,double_float.size))
	__(stfd f0,double_float.value(arg_z))
	__(blr)
	
_spentry(makesingle)
	__(li imm0,single_float_header)
	__(Misc_Alloc_Fixed(arg_z,imm0,single_float.size))
	__(stfs f0,single_float.value(arg_z))
	__(blr)

_spentry(makeptr)
	__(li imm1,macptr_header)
	__(Misc_Alloc_Fixed(arg_z,imm1,macptr.size))
	__(str(imm0,macptr.address(arg_z)))
	__(blr)

/*  EOF, basically */
        .org local_label(start)+65536-4
        xjmp(_SPsp_end)
	_endfile
